package ui;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import core.Mapper;

public class MapperUISliderRaz extends JFrame{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private MapperPanel mapperPanel=null;
	private ControlPanel controlPanel=null;
	private Mapper mapper=null;
	
	ZoomSlider z;
	ZoomRaz zraz;
	SlidePanel zoom;
	
	public MapperUISliderRaz(Mapper mapper){
		this.mapper=mapper;
		setTitle("Mapper");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setLayout(new BorderLayout());
		setResizable(false);
		mapperPanel=new MapperPanel();
		controlPanel=new ControlPanel();
		add(mapperPanel,BorderLayout.LINE_START);
		add(controlPanel,BorderLayout.CENTER);
		pack();
		setVisible(true);
	}
	
	class ControlPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public ControlPanel(){
			setLayout(new BoxLayout(this,BoxLayout.PAGE_AXIS));
			setBorder(BorderFactory.createTitledBorder("Control"));
			z=new ZoomSlider(JSlider.HORIZONTAL,0,100,(int)(mapper.getZoom()*100));
			z.addChangeListener(z);
			
			zraz=new ZoomRaz();
			zraz.setText("RAZ");
			zraz.addActionListener(zraz);
			
			zoom=new SlidePanel("zoom");
			zoom.add(z);
			zoom.add(zraz);
			
			add(zoom);
		}
	}
	
	class ZoomRaz extends JButton implements ActionListener{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public void actionPerformed(ActionEvent e) {
			mapper.resetZoom();
			z.setValue((int)(mapper.getZoom()*100));
			mapperPanel.repaint();
		}
	}
	
	class ZoomSlider extends JSlider implements ChangeListener{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		public ZoomSlider(int horizontal, int i, int j, int k) {
			super(horizontal,i,j,k);
		}
		public void stateChanged(ChangeEvent e) {
			mapper.setZoom(((JSlider)e.getSource()).getValue()/100d);
			mapperPanel.repaint();
		}		
	}
	
	class MapperPanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;
		public MapperPanel(){
			setPreferredSize(mapper.getDimension());
			setBackground(Color.blue);
		}
		protected void paintComponent(Graphics g){
			Graphics2D g2d=(Graphics2D)g;
			g2d.drawImage(mapper.getImage(),null,this);
		}
	}
	
	class SlidePanel extends JPanel{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public SlidePanel(String name){
			setBorder(BorderFactory.createTitledBorder(name));
		}
	}
	
}
